var regEx = /<td>(\d+)\s*downloads?<\/td>/;
var xmlHttp;
var spinner;
var labelLength = 90;
var currentPage = 0;
var blogUrl = "";
var wordPressApi = "";
var day = "today";
var wordPressStatsLogin = "";
var wordPressStatsPassword = "";
var reloadInterval = 60;
var statsPageUrl = "";
var error = "";

var pages = new Array({ label: "Blog Stats", id: "blogStats" }, { label: "Top Posts & Pages", id: "topPages" }, { label: "Referrers", id: "referrers" }, { label: "Search Engine Terms", id: "searchEngineTerms" }, { label: "Clicks", id: "clicks" }, { label: "Incoming Links", id: "incomingLinks" });

var Stats = {};

function init()
{
	currentPage = 0;
	System.Gadget.settingsUI = "settings.html";
	System.Gadget.onSettingsClosed = SettingsClosing;
	
	blogUrl = System.Gadget.Settings.readString("blogUrl");
	wordPressApi = System.Gadget.Settings.readString("wordPressApi");
	day = System.Gadget.Settings.readString("day");
	wordPressStatsLogin = System.Gadget.Settings.readString("wordPressStatsLogin");
	wordPressStatsPassword = System.Gadget.Settings.readString("wordPressStatsPassword");
	reloadInterval = System.Gadget.Settings.read("refreshInterval");

	$("controls").style.display = "none";
  
	if (blogUrl.length > 0 && wordPressApi.length > 0)
	{
		$("spinnerWrapper").innerHTML = "<span id=\"spinner\"></span>&nbsp;Getting data...";
		$("spinnerWrapper").style.display = "block";
		$("stats").innerHTML = "";

		spinner = new Common.getSpinner("spinner");
		spinner.start();
	
		buildStatsPageUrl();
	}
	else
	{
		showInfo("Configure blog");
	}
}

function queryData()
{
	if (statsPageUrl.length > 0)
	{
		downloadsString = "";
		loadData();
		
		window.setTimeout("init()", reloadInterval * 1000 * 60);
	}
	else
	{
		var msg = error.length > 0 ? error : "WordPress API error";
		showError(msg);
	}
}

function buildStatsPageUrl()
{
	var xml = '<?xml version="1.0"?><methodCall><methodName>wpStats.get_blog_id</methodName><params><param><value><string>' + wordPressApi + '</string></value></param><param><value><struct>  <member><name>host</name><value><string>' + blogUrl + '</string></value></member></struct></value></param></params></methodCall>';
    
	var xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
	xmlHttp.onreadystatechange = function()
	{
		if (xmlHttp.readyState == 4)
	    {
			var regEx = /<member><name>blog_id<\/name><value><int>([^<]+)<\/int>/i;
			var errorRegEx = /<member>[^<]*<name>faultString<\/name>[^<]*<value><string>([^<]+)<\/string><\/value>[^<]*<\/member>/i;
			var response = xmlHttp.responseText;
		  
			if (regEx.test(response))
			{
				statsPageUrl = "http://dashboard.wordpress.com/wp-admin/index.php?page=estats&amp;blog=" + regEx.exec(response)[1] + "&amp;noheader=true";
				queryData();
			}
			else
			{
				spinner.stop();
				spinner.hide();
			
				if (errorRegEx.test(response))
					error = errorRegEx.exec(response)[1];
					
				var msg = error.length > 0 ? error : "WordPress API error";
				showError(msg);
			}
		}
	}
	xmlHttp.open("POST", "http://wordpress.com/xmlrpc.php", true);
	xmlHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	xmlHttp.send(xml);
}

function SettingsClosing(event)
{
	if (event.closeAction == event.Action.commit)
	{
		init();
	}
	
	event.cancel = false;
}

function loadData()
{
	xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
	xmlHttp.onreadystatechange = function()
	{
		if (xmlHttp.readyState == 4)
		{				
			var data = xmlHttp.responseText;
			if (data != null)
			{
				spinner.stop();
				spinner.hide();
				
				// check if the user is logged in
				if (data.indexOf("id=\"loginform\"") == -1)
				{
				  $("spinnerWrapper").style.display = "none";
				  $("statsDoc").innerHTML = data;
				  $("controls").style.display = "block";
				
				  processStats();
  				
				  go(1);
				}
				else
				{
				  $("statsDoc").innerHTML = data;
				  // attempt login
				  if (wordPressStatsLogin.length > 0 && wordPressStatsPassword.length > 0)
				  {
				    var loginHttp = new ActiveXObject("Microsoft.XMLHTTP");
				    loginHttp.onreadystatechange = function()
				    {
				      if (loginHttp.readyState == 4)
				      {
				        
				        var data = loginHttp.responseText;
				        if (data.indexOf("id=\"login_error\"") == -1)
				        {
							init();
				        }
				        else
				        {
							showError("Login error");
				        }
				      }
				    }
				    loginHttp.open("POST", "https://dashboard.wordpress.com/wp-login.php", true);
				    loginHttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
				    loginHttp.send("log=" + wordPressStatsLogin + "&pwd=" + wordPressStatsPassword + "&wp-submit=Log+In&redirect_to=" + encodeURIComponent(statsPageUrl) + "&testcookie=1");
				  }
				  else
				  {
					showError("Cannot log in");
				  }
				}
			}
		}
	}
	xmlHttp.open("GET", statsPageUrl + "&rand=" + Math.random(), true);
	xmlHttp.send();
}

function go(dir)
{
  if (dir == -1 && currentPage == 0)
    currentPage = pages.length;
    
  if (dir == 1 && currentPage == pages.length-1)
    currentPage = -1;
   
  currentPage += dir;
  
  var previousPage = currentPage == 0 ? pages.length-1 : currentPage-1;
  var nextPage = currentPage == pages.length-1 ? 0 : currentPage+1;
  $("prev").title = pages[previousPage].label;
  $("next").title = pages[nextPage].label;
  $("currentPage").innerHTML = pages[currentPage].label;
  $("currentPage").style.bottom = pages[currentPage].label.visualLength() > 55 ? "6px" : "5px";
  displayStats(eval("Stats." + pages[currentPage].id));
}


function displayStats(stats)
{
	var statsString = "";
	var max = stats.length > 6 ? 6 : stats.length;
	
	for (var i = 0; i < max; i++)
	{
		var stat = stats[i];
		var label = "";
		if (stat.url != null)
		  label = "<a href=\"" + stat.url + "\" title=\"" + stat.label + "\">" + stat.shortLabel + "</a>";
		else
		  label = stat.label;
		
		if (stats === Stats.incomingLinks)
		  statsString += "<tr><td>" + label + "</td></tr>";
		else
		  statsString += "<tr><td>" + label + "</td><td align=\"right\">" + stat.value + "</td></tr>";
	}
	
	$("stats").innerHTML = "<table>" + statsString + "</table>";
}

function processStats()
{
  Stats.blogStats = processBlogStats();
	Stats.topPages = processDailySection("postviews");
	Stats.referrers = processDailySection("referrers");
	Stats.searchEngineTerms = processDailySection("searchterms");
	Stats.clicks = processDailySection("clicks");
	Stats.incomingLinks = processIncomingLinks();
}

function processIncomingLinks()
{
  var section = $("incominglinks");
  var incomingLinksNodes = section.getElementsByTagName("UL")[0];
  var incomingLinks = new Array(incomingLinksNodes.childNodes.length);
  
  for (var i = 0; i < incomingLinks.length; i++)
  {
    var incomingLink = incomingLinksNodes.childNodes[i].firstChild;
    incomingLinks[i] = new StatInfo(incomingLink.innerHTML, incomingLink.href, null);
  }
  
  return incomingLinks;
}

function processBlogStats()
{
  var section = $("generalblog");
  var blogStats = section.getElementsByTagName("P");
  var stats = new Array(blogStats.length);
  
  for (var i = 0; i < blogStats.length; i++)
  {
    var info = blogStats[i];
    var label = info.firstChild.innerHTML.substring(0, info.firstChild.innerHTML.length-1);
    var value = "";
    if (info.lastChild.nodeName == "A")
    {
      value = info.lastChild.innerHTML;
    }
    else
    {
      value = info.lastChild.nodeValue;
    }
    stats[i] = new StatInfo(label, null, value);
  }
  
  return stats;
}

function processDailySection(sectionName)
{
	var section = $(sectionName);
	var sections = section.getElementsByTagName("H4");
	var sectionId = day == "today" ? 0 : 1;
	var today = sections[sectionId].nextSibling;
	var todayItems = new Array(today.rows.length-1);
	for (var i = 1; i < today.rows.length; i++)
	{
		var row = today.rows[i];
		var node = row.cells[0].firstChild;
		var label = "";
		var link = "";
		if (node.nodeName == "A")
		{
			label = node.innerHTML;
			link = node.href;
		}
		else
		{
			label = node.nodeValue;
		}
		todayItems[i-1] = new StatInfo(label, link, row.cells[1].innerHTML);
	}
	
	return todayItems;
}

function StatInfo(label, url, value)
{
	this.label = label;
	this.shortLabel = label.trimToPx(labelLength)
	this.url = url;
	this.value = value;
}

/*
 * Common Functions
 */
function $(id)
{
	return document.getElementById(id);
}

function bg(obj, img)
{
  obj.style.backgroundImage = 'url("../images/' + img + '")';
}

function showError(msg)
{
	showMessage('<img src="images/error16.png" class="icon" />' + msg);
}

function showWarning(msg)
{
	showMessage('<img src="images/warning16.png" class="icon" />' + msg);
}

function showInfo(msg)
{
	showMessage('<img src="images/info16.png" class="icon" />' + msg);
}

function showMessage(msg)
{
	$("spinnerWrapper").innerHTML = '<span id="message">' + msg + '</span>';
	$("spinnerWrapper").style.display = "block";
	$("controls").style.display = "none";
}

var Common = {}
Common.getSpinner = function(spinnerDivID) 
{
  var self = this;
  this.id = spinnerDivID;
  this.parentDiv = document.getElementById(self.id);
  this.fps = 1000/30;
  with (this.parentDiv.style) 
  {
	fontSize=0;
	posWidth=16;
	posHeight=16;
	backgroundImage = 'url("images/activity16v.png")';
	backgroundPositionY = 0;
  }
  this.hide = function() 
  { 
	self.parentDiv.style.display='none';  
  }
  this.show = function() 
  { 
	self.parentDiv.style.display='block'; 
  }
  this.stop = function() 
  { 
	clearInterval(self.animationInterval); 
  }
  this.start = function() 
  {
	clearInterval( self.animationInterval );
	this.animationInterval = setInterval('Common.animateSpinner("' + self.id + '")', 30);
  }
}

Common.animateSpinner = function(spinnerDiv) 
{
  $(spinnerDiv).style.backgroundPositionY=parseInt($(spinnerDiv).style.backgroundPositionY)-16; 
}

String.prototype.visualLength = function()
{
	var ruler = $("ruler");
	ruler.innerHTML = this;
	return ruler.offsetWidth;
}

String.prototype.trimToPx = function(length)
{
	var tmp = this;
	var trimmed = this;
	if (tmp.visualLength() > length)
	{
		trimmed += "...";
		while (trimmed.visualLength() > length)
		{
			tmp = tmp.substring(0, tmp.length-1);
			trimmed = tmp + "...";
		}
	}
	
	return trimmed;
}